Bug 1267496 - Review Request: python-reno: Release NOtes manager
Review Request: python-reno: Release NOtes manager
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Javier Peña
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2015-09-30 04:07 EDT by Chandan Kumar
Modified: 2016-06-17 09:29 EDT (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-06-17 09:29:18 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
jpena: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Chandan Kumar 2015-09-30 04:07:41 EDT
Spec URL: https://chandankumar.fedorapeople.org/python-reno.spec

SRPM URL: https://chandankumar.fedorapeople.org/python-reno-0.1.0-1.fc22.src.rpm 
Description: Reno is a release notes manager for storing
release notes in a gitnrepository and then building documentation from them.

Fedora Account System Username: chandankumar

Kiji Build: http://koji.fedoraproject.org/koji/taskinfo?taskID=11274918
Comment 1 Javier Peña 2015-09-30 04:31:53 EDT
Hi Chandar,

On a first look, I see the following changes are required:

- Move BuildRequires to the corresponding subpackages
- sphinx-build should belong to %install, rather than %build
- Do not remove eggs in %prep. I've been told a few times it was a mistake in the guidelines, but can't find the link right now :).

Everything else looks ok. Thanks!
Comment 2 Javier Peña 2015-09-30 04:32:10 EDT
Hi Chandan,

On a first look, I see the following changes are required:

- Move BuildRequires to the corresponding subpackages
- sphinx-build should belong to %install, rather than %build
- Do not remove eggs in %prep. I've been told a few times it was a mistake in the guidelines, but can't find the link right now :).

Everything else looks ok. Thanks!
Comment 3 Javier Peña 2015-09-30 04:33:03 EDT
Mmm, no way to undo a comment? :o)
Comment 4 Chandan Kumar 2015-09-30 04:42:55 EDT
Thanks Jpena for the review.

Below is the updated
SPEC: https://chandankumar.fedorapeople.org/python-reno.spec
SRPM: https://chandankumar.fedorapeople.org/python-reno-0.1.0-2.fc22.src.rpm

Thanks,

Chandan Kumar
Comment 5 Javier Peña 2015-09-30 09:38:21 EDT
In case the IRC comments got lost, I have two more items to fix:

- Now that BuildRequires are in the subpkg sections, there is no need for them in the global section.
- I think some Requires are missing, at least PyYAML is being used.

Thanks!
Comment 6 Chandan Kumar 2015-09-30 14:44:07 EDT
Hello Jpena,

Thanks for the review.

Here is the updated
SPEC: https://chandankumar.fedorapeople.org/python-reno.spec

SRPM: https://chandankumar.fedorapeople.org/python-reno-0.1.0-2.fc22.src.rpm

Thanks,

Chandan Kumar
Comment 7 Javier Peña 2015-10-01 05:37:27 EDT
I hereby approve this package into Fedora Packages Collection, please submit a SCM request.


This is a review *template*. Besides handling the [ ]-marked tests you are
also supposed to fix the template before pasting into bugzilla:
- Add issues you find to the list of issues on top. If there isn't such
  a list, create one.
- Add your own remarks to the template checks.
- Add new lines marked [!] or [?] when you discover new things not
  listed by fedora-review.
- Change or remove any text in the template which is plain wrong. In this
  case you could also file a bug against fedora-review
- Remove the "[ ] Manual check required", you will not have any such lines
  in what you paste.
- Remove attachments which you deem not really useful (the rpmlint
  ones are mandatory, though)
- Remove this text



Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Apache (v2.0)", "Unknown or generated", "*No copyright* Apache
     (v2.0)". 1 files have unknown license. Detailed output of licensecheck
     in /tmp/1267496-python-reno/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 4 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[-]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     python2-reno , python3-reno , python-reno-doc
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python2-reno-0.1.0-2.fc24.noarch.rpm
          python3-reno-0.1.0-2.fc24.noarch.rpm
          python-reno-doc-0.1.0-2.fc24.noarch.rpm
          python-reno-0.1.0-2.fc24.src.rpm
python2-reno.noarch: W: spelling-error Summary(en_US) RElease -> Release, Releases, Released
python2-reno.noarch: W: spelling-error %description -l en_US gitnrepository -> repository
python2-reno.noarch: W: no-manual-page-for-binary reno
python3-reno.noarch: W: spelling-error Summary(en_US) RElease -> Release, Releases, Released
python3-reno.noarch: W: spelling-error %description -l en_US gitnrepository -> repository
python3-reno.noarch: W: no-manual-page-for-binary reno
python-reno-doc.noarch: W: summary-not-capitalized C reno documentation
python-reno.src: W: spelling-error %description -l en_US gitnrepository -> repository
python-reno.src:35: W: mixed-use-of-spaces-and-tabs (spaces: line 7, tab: line 35)
4 packages and 0 specfiles checked; 0 errors, 9 warnings.




Rpmlint (installed packages)
----------------------------
python3-reno.noarch: W: no-manual-page-for-binary reno
python2-reno.noarch: W: no-manual-page-for-binary reno
python-reno-doc.noarch: W: summary-not-capitalized C reno documentation
3 packages and 0 specfiles checked; 0 errors, 3 warnings.



Requires
--------
python3-reno (rpmlib, GLIBC filtered):
    /usr/bin/python2
    python(abi)
    python3-PyYAML
    python3-babel
    python3-pbr

python2-reno (rpmlib, GLIBC filtered):
    /usr/bin/python2
    PyYAML
    python(abi)
    python-babel
    python-pbr

python-reno-doc (rpmlib, GLIBC filtered):



Provides
--------
python3-reno:
    python3-reno

python2-reno:
    python-reno
    python2-reno

python-reno-doc:
    python-reno-doc



Source checksums
----------------
https://pypi.python.org/packages/source/r/reno/reno-0.1.0.tar.gz :
  CHECKSUM(SHA256) this package     : 70955f5210113a943f96c92fa8c35fb21ec2b531c7cf1bdb816c63b5e51a367b
  CHECKSUM(SHA256) upstream package : 70955f5210113a943f96c92fa8c35fb21ec2b531c7cf1bdb816c63b5e51a367b


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -b 1267496 -m fedora-rawhide-x86_64
Buildroot used: fedora-rawhide-x86_64
Active plugins: Python, Generic, Shell-api
Disabled plugins: Java, C/C++, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6
Comment 8 Chandan Kumar 2015-10-01 13:14:08 EDT
New Package SCM Request
=======================
Package Name: python-reno
Short Description: Release NOtes manager
Upstream URL:  http://www.openstack.org/
Owners: chandankumar apevec
Branches: f23
InitialCC:
Comment 9 Gwyn Ciesla 2015-10-02 07:31:38 EDT
Git done (by process-git-requests).
Comment 10 Toshio Ernie Kuratomi 2015-11-10 10:24:40 EST
A few notes:
* Since this package is now in the distribution, this review ticket can now be closed.
* When packaging python2/python3 packages you need to be careful about your dependencies.  In https://bugzilla.redhat.com/show_bug.cgi?id=1267496#c7 fedora-review spit out the Requires for both subpackages.  python3-reno requires /usr/bin/python2 which is an indication that there's something wrong with the package.
* When a package provides both python2 and python3 subpackages, you need to take care of which interpreter the executable is using and in which subpackage it is placed.  I just committed this patch to rawhide: http://pkgs.fedoraproject.org/cgit/python-reno.git/commit/  which fixes this particular package.

For this package, the /usr/bin/reno script is not functionally different when it runs under python2 or python3.  So the packaging guidelines tell us that in this case we should only ship one version of the script, running against python3 (from fedora22 onward): https://fedoraproject.org/wiki/Packaging:Python#Avoiding_collisions_between_the_python_2_and_python_3_stacks

Note: In a few packages running under python2 vs python3 does make a difference.  Many unittest frameworks, for instance, can only inspect python2 code if the executable is run under python2 and can only inspect python3 code if it is run under python3.  The guidelines specify a way to rename the executable that's shipped in the python3 package to deal with those situations.  That's not the case here.

Thanks to both of you for packaging and reviewing.  Hopefully this comment gives you some information that you can use when packaging and reviewing future python3 packages.
Comment 11 Alan Pevec 2015-11-30 18:43:00 EST
> * When a package provides both python2 and python3 subpackages, you need to
> take care of which interpreter the executable is using and in which
> subpackage it is placed.  I just committed this patch to rawhide:
> http://pkgs.fedoraproject.org/cgit/python-reno.git/commit/  which fixes this
> particular package.

Thanks, but I can't help to note that this is very inelegant, as the whole python2/3 in Fedora :(
I don't have a solution, I'm just complaining, but I hope we could eventually end up with macros or pre-processing spec, to generate both py2 and py3 packages from a single clean spec without %ifs and duplicate lines...

Note You need to log in before you can comment on or make changes to this bug.